﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Reflection;
using System.Diagnostics;

namespace _101919
{
    public partial class Form1 : Form
    {
        class BorderElementsFlagManager:INotifyPropertyChanged
        {
            MyDraw.BorderElements value;


            public MyDraw.BorderElements Value
            {
                get { return this.value; }
                set { this.value = value;
                    Notify("Value");
                    manageIsOn(value);
                }
            }

            private void manageIsOn(MyDraw.BorderElements value)
            {
                foreach (MyDraw.BorderElements e in Enum.GetValues(typeof(MyDraw.BorderElements)))
                {
                    this.GetType().GetProperty(string.Format("{0}IsOn", e)).SetValue(this, value.HasFlag(e), null);
                }
            }

            private void manageIsOn()
            {
                MyDraw.BorderElements flags = MyDraw.BorderElements.None;
                foreach (PropertyInfo pinfo in this.GetType().GetProperties().Where(prop => (prop.PropertyType == typeof(bool) && prop.Name != "Value")))
                {
                    if ((bool)pinfo.GetValue(this, null))
                    {
                        if(flags == MyDraw.BorderElements.None)
                            flags =  (MyDraw.BorderElements)Enum.Parse(typeof(MyDraw.BorderElements), pinfo.Name.Replace("IsOn", ""));
                        else
                            flags |= (MyDraw.BorderElements)Enum.Parse(typeof(MyDraw.BorderElements), pinfo.Name.Replace("IsOn", ""));
                    }
                }
                this.value = flags;
                Notify("Value");
            }

            bool noneIsOn;
            public bool NoneIsOn
            {
                get { return noneIsOn; }
                set { noneIsOn = value;
                Notify("NoneIsOn");
                if (value)
                {
                    this.SummaryFooterCaptionIsOn = false;
                    this.SummaryFooterIsOn = false;
                    this.SummaryValueIsOn = false;
                    this.FixedSummaryAreaIsOn = false;
                    this.FreeFormSummaryAreaIsOn = false;
                }
                }
            }
            
            bool summaryFooterCaptionIsOn;
            public bool SummaryFooterCaptionIsOn
            {
                get { return summaryFooterCaptionIsOn; }
                set { summaryFooterCaptionIsOn = value;
                Notify("SummaryFooterCaptionIsOn");
                if (value)
                    this.NoneIsOn = false;
                }
            }
            
            bool fixedSummaryAreaIsOn;
            public bool FixedSummaryAreaIsOn
            {
                get { return fixedSummaryAreaIsOn; }
                set { fixedSummaryAreaIsOn = value;
                Notify("FixedSummaryAreaIsOn");
                if (value)
                    this.NoneIsOn = false;
                }
            }
            
            bool freeFormSummaryAreaIsOn;
            public bool FreeFormSummaryAreaIsOn
            {
                get { return freeFormSummaryAreaIsOn; }
                set { freeFormSummaryAreaIsOn = value;
                Notify("FreeFormSummaryAreaIsOn");
                if (value)
                    this.NoneIsOn = false;
                }
            }
            
            bool summaryValueIsOn;
            public bool SummaryValueIsOn
            {
                get { return summaryValueIsOn; }
                set { summaryValueIsOn = value;
                Notify("SummaryValueIsOn");
                if (value)
                    this.NoneIsOn = false;
                }
            }
            
            bool summaryFooterIsOn;
            public bool SummaryFooterIsOn
            {
                get { return summaryFooterIsOn; }
                set { summaryFooterIsOn = value;
                Notify("SummaryFooterIsOn");
                if (value)
                    this.NoneIsOn = false;
                }
            }

            public event PropertyChangedEventHandler PropertyChanged;
            private void Notify(string property)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged.Invoke(this, new PropertyChangedEventArgs(property));
                    if (property != "Value")
                        manageIsOn();
                }
            }
        }

        MyDraw drawFilter = new MyDraw();
        BorderElementsFlagManager manager = new BorderElementsFlagManager();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            DataTable dt = new DataTable("Table");
            dt.Columns.Add("Product Category", typeof(string));
            dt.Columns.Add("Period", typeof(int));
            dt.Columns.Add("Sales", typeof(int));
            dt.Columns.Add("Amount", typeof(double));
            dt.Columns.Add("AVG_Qty", typeof(double));
            dt.Columns.Add("AVG Amount", typeof(double));

            dt.Rows.Add("Cat1", 7, 10, 1258.00, 1.43, 179.71);
            dt.Rows.Add("Cat2", 10, 15, 1442.00, 1.50, 144.20);
            dt.Rows.Add("Cat3", 16, 50, 2015.00, 3.13, 125.94);
            dt.Rows.Add("Cat4", 3, 35, 1720.00, 11.67, 573.33);

            ultraGrid1.DataSource = dt;
            
            drawFilter.PropertyChanged += new PropertyChangedEventHandler(drawFilter_PropertyChanged);
            manager.PropertyChanged += new PropertyChangedEventHandler(manager_PropertyChanged);
            #region manage DrawFilter
            Point p = new Point(10, 20);
            foreach (MyDraw.BorderElements be in Enum.GetValues(typeof(MyDraw.BorderElements)))
            {
                CheckBox cb = new CheckBox();
                cb.Text = be.ToString();
                if (be == MyDraw.BorderElements.SummaryFooter)
                    cb.Text += " (all)";
                cb.Location = p;
                cb.AutoSize = true;
                groupBox1.Controls.Add(cb);
                p.Offset(0, 22);
                cb.CheckStateChanged += new EventHandler(cb_CheckStateChanged);
                Binding b = cb.DataBindings.Add("Checked", manager, string.Format("{0}IsOn", be));
                b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;
                b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            }
            #endregion

            

        }

        void cb_CheckStateChanged(object sender, EventArgs e)
        {
            ultraGrid1.Refresh();
        }

        void manager_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Value")
            {
                drawFilter.PropertyChanged-=new PropertyChangedEventHandler(drawFilter_PropertyChanged);
                drawFilter.SkipBordersOf = manager.Value;
                drawFilter.PropertyChanged += new PropertyChangedEventHandler(drawFilter_PropertyChanged);
            }
        }

        void drawFilter_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "SkipBordersOf")
            {
                manager.PropertyChanged -=new PropertyChangedEventHandler(manager_PropertyChanged);
                 manager.Value= drawFilter.SkipBordersOf;
                 manager.PropertyChanged += new PropertyChangedEventHandler(manager_PropertyChanged);
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridBand band = e.Layout.Bands[0];
            SummarySettings set = band.Summaries.Add(SummaryType.Count, band.Columns["Product Category"]);
            set.DisplayFormat = "Count= {0} Items";

            set = band.Summaries.Add(SummaryType.Sum, band.Columns["Period"]);
            set.DisplayFormat = "{0}";
            band.Columns["Period"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;

            set = band.Summaries.Add(SummaryType.Sum, band.Columns["Sales"]);
            set.DisplayFormat = "{0}";
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
            band.Columns["Sales"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;

            set = band.Summaries.Add(SummaryType.Sum, band.Columns["Amount"]);
            set.DisplayFormat = "{0}";
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
            band.Columns["Amount"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;

            set = band.Summaries.Add(SummaryType.Average, band.Columns["AVG_Qty"]);
            string AVG_Qty = set.FormulaAbsoluteName;
            set.DisplayFormat = "{0}";
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
            band.Columns["AVG_Qty"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;

            set = band.Summaries.Add(SummaryType.Average, band.Columns["AVG Amount"]);
            string AVG_Amount = set.FormulaAbsoluteName;
            set.DisplayFormat = "{0}";
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
            band.Columns["AVG Amount"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;


            set = band.Summaries.Add("Grand average", string.Format("average( [{0}], [{1}] )", AVG_Amount, AVG_Qty));
            set.SummaryPosition = SummaryPosition.Right;
           
            set.DisplayFormat = "AVG Qty/Amount = {0}";
            set.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;

            e.Layout.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.None;


        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            groupBox1.Enabled = ((RadioButton)sender).Checked;
            if (((RadioButton)sender).Checked)
            {
                ultraGrid1.DrawFilter = drawFilter;
            }
            else
            {
                ultraGrid1.DrawFilter = null;
            }
        }

        private void cbSummaryFooterAppearance_CheckedChanged(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked)
                ultraGrid1.DisplayLayout.Override.SummaryFooterAppearance.BorderColor = Color.Transparent;
            else
                ultraGrid1.DisplayLayout.Override.SummaryFooterAppearance.ResetBorderColor();

        }

        private void cbSummaryFooterCaptionAppearance_CheckedChanged(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked)
                ultraGrid1.DisplayLayout.Override.SummaryFooterCaptionAppearance.BorderColor = Color.Transparent;
            else
                ultraGrid1.DisplayLayout.Override.SummaryFooterCaptionAppearance.ResetBorderColor();
        }

        private void cbSummaryValueAppearance_CheckedChanged(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked)
                ultraGrid1.DisplayLayout.Override.SummaryValueAppearance.BorderColor = Color.Transparent;
            else
                ultraGrid1.DisplayLayout.Override.SummaryValueAppearance.ResetBorderColor();
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            groupBox2.Enabled = ((RadioButton)sender).Checked;
            ultraGrid1.DisplayLayout.Override.SummaryValueAppearance.ResetBorderColor();
            ultraGrid1.DisplayLayout.Override.SummaryFooterCaptionAppearance.ResetBorderColor();
            ultraGrid1.DisplayLayout.Override.SummaryFooterAppearance.ResetBorderColor();
        }

        
    }
}
